<?php

class CSVParser {
    
    const PROGRAMOFFERFILE = "programs.txt";
    const USERLISTFILE = "users.txt";
    const APPLYLISTFILE = "applies.txt";
    
    private $filename;
    private $lines;
    
    
    
    
    public function __construct($filename) {
        $this->filename = $filename;
        $this->parseFile();
    }
    
    
    
    
    public function eraseLines() {
        $this->lines = array();
    }
    
    public function parseFile() {
        $this->eraseLines();
        
        $file = fopen($this->filename, "r");
        while (!feof($file)) {
            $line = fgetcsv($file, 99999, ";");
            if (isset($line[0]) && $line[0]!=null) {
                $this->lines[] = $line;
            }
        }
        fclose($file);
    }
    
    public function getAllLines() {
        return $this->lines;
    }
    
    public function getCSVHeader() {
        return $this->lines[0];
    }
    
    public function getCSVDataLines() {
        $notwanted = $this->lines[0];
        return array_diff_assoc($this->lines, array($notwanted));
    }
    
    public function appendRecord($array) {
        if (is_array($array)) {
            $file = fopen($this->filename, "a");
            fputcsv($file, $array, ";");
            fclose($file);
        }
    }
    
}
