<?php

class FormGenerator {
    
    private $formName;
    private $formElements;
    private $formErrors;
    private $submitLabel;
    private $formSuccess;
    
    
    
    
    public function __construct($formName) {
        $this->formName = $formName;
        $this->formElements = array();
        $this->formErrors = array();
        $this->formSuccess = array();
        $this->submitLabel = "Mehet";
    }
    
    
    
    
    public function addFormElement($type, $name, $label, $value = "") {
        $this->formElements[] = array("type"=>$type, "name"=>$name, "label"=>$label, "value"=>$value);
    }
    
    public function addSubmitButton($submitLabel) {
        $this->submitLabel = $submitLabel;
    }    
    
    public function addFormError($errorLabel) {
        $this->formErrors[] = $errorLabel;
    }  
        
    public function addFormSuccess($successLabel) {
        $this->formSuccess[] = $successLabel;
    }
    
    public function getCurrentURL() {
        $pageURL = (@$_SERVER["HTTPS"] == "on") ? "https://" : "http://";
        if ($_SERVER["SERVER_PORT"] != "80") {
            $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
        } 
        else {
            $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
        }
        return $pageURL;
    }

    public function render() { 
    ?>
                    <form name="<?php echo $this->formName; ?>" action="<?php echo $this->getCurrentURL(); ?>" method="POST">
        <?php if (count($this->formErrors)>0): ?>
                        <div class="elementgroup">
            <?php foreach ($this->formErrors as $errorText): ?>
                            <p class="error"><?php echo $errorText; ?></p>
            <?php endforeach; ?>
                        </div>
        <?php endif;
        
              if (count($this->formSuccess)>0): ?>
                        <div class="elementgroup">
            <?php foreach ($this->formSuccess as $successText): ?>
                            <p class="success"><?php echo $successText; ?></p>
            <?php endforeach; ?>
                        </div>
        <?php endif;
            
            foreach ($this->formElements as $element): 
                $inputName = $this->formName."[".$element["name"]."]";
            
                switch ($element["type"]) {

                    case "text": ?>
                        
                        <div class="elementgroup">
                            <label for="<?php echo $inputName; ?>"><?php echo $element["label"]; ?></label>
                            <input name="<?php echo $inputName; ?>" id="<?php echo $inputName; ?>" type="text" value="<?php echo $element["value"]; ?>" />
                        </div>
                        
                    <?php break;
                    
                    case "pass": ?>
                        
                        <div class="elementgroup">
                            <label for="<?php echo $inputName; ?>"><?php echo $element["label"]; ?></label>
                            <input name="<?php echo $inputName; ?>" id="<?php echo $inputName; ?>" type="password" value="<?php echo $element["value"]; ?>" />
                        </div>
                        
                    <?php break;
                } //end switch
            endforeach; ?>
                        <div class="elementgroup">
                            <input type="submit" value="<?php echo $this->submitLabel; ?>" />
                        </div>
                    </form>
<?php
    }//end render
    
}