<?php


class MenuManager {
    
    private $menu;
    
    
    
    public function __construct() {
        $this->menu = array(
            "fooldal"   => "Programok",
            "login"     => "Bejelentkezés",
            "logout"    => "Kijelentkezés",
            "reg"       => "Regisztráció",
            "admin"     => "Adminisztráció",
        );
    }
    
    public function getTitleByPage($page) {
        return $this->menu[$page];
    }
    
    public function getMenu() {
        global $USERS;
        
        $retrun = $this->menu;
        if ($USERS->isLoggedIn()) {
            $retrun = array_diff_key($retrun, array("login"=>"","reg"=>""));
            
            if (!$USERS->isAdmin()) {
                $retrun = array_diff_key($retrun, array("admin"=>""));
            }
        }
        else {
            $retrun = array_diff_key($retrun, array("logout"=>"","admin"=>""));
        }
        
        return $retrun;
    }
    
    public function render() {
        $menuToRender = $this->getMenu();
    ?>
                    <h3>Menü</h3>
                    <ul id="menu">
                        <?php foreach ($menuToRender as $link => $label): ?>
                        <li><a href="?p=<?php echo $link; ?>"><?php echo $label; ?></a></li>
                        <?php endforeach; ?>
                    </ul>
<?php
    }
    
}