<?php

class TableGenerator {
    
    private $tableName;
    private $tableHead;    
    private $tableBody;
    private $excludeCols;
    private $colPattern;
    
    
    
    public function __construct($tableName = "") {
        $this->tableName = $tableName;
        $this->tableHead = array();
        $this->tableBody = array();
        $this->excludeCols = array();
        $this->colPattern = "";
    }
    
    
    

    public function setTableHead($headElements) {
        if (is_array($headElements)) {
            $this->tableHead = $headElements;
        }
    }   
    
    public function setTableBody($bodyElements) {
        if (is_array($bodyElements)) {
            $this->tableBody = $bodyElements;
        }
    }
    
    public function setExcludeCols($excludeCols) {
        if (is_array($excludeCols)) {
            $this->excludeCols = $excludeCols;
        }
    }
    
    public function addAnotherBodyRow($oneMoreRow) {
        if (is_array($oneMoreRow)) {
            $this->tableBody[] = $oneMoreRow;
        }
    }
    
    public function setTaskCol($colHeader, $colPattern) {
        $this->tableHead[] = $colHeader;
        $this->colPattern = $colPattern;
    }

    public function render() { 
        if ($this->tableName == "programs") {
            if ($this->colPattern != "") { //'<a href="?p=apply&id=%">Művelet neve</a>'
                foreach($this->tableBody as &$row) {
                    if ($row[5]>0 && trim($row[4])=="Igen") {
                        $row[] = str_replace("%", $row[0], $this->colPattern);
                    }
                    else {
                        $row[] = "";
                    }
                }
                unset($row);
            }
        }
        else {
            if ($this->colPattern != "") { //'<a href="?p=apply&id=%">Művelet neve</a>'
                foreach($this->tableBody as &$row) {
                    $row[] = str_replace("%", $row[0], $this->colPattern);
                }
                unset($row);
            }
        }
    ?>
                    <table id="gentable" border="0">
                        <thead>
                            <tr>
                                <?php foreach($this->tableHead as $key => $value): 
                                    if (!in_array($key, $this->excludeCols)):
                                ?>
                                <th><?php echo $value; ?></th>
                                <?php endif; 
                                endforeach; ?>
                            </tr>
                        </thead>
                        <tbody>
                            <?php foreach($this->tableBody as $row): ?>
                            <tr>
                                <?php foreach($this->tableHead as $key => $value): 
                                    if (!in_array($key, $this->excludeCols)):
                                ?>
                                <td><?php echo $row[$key]; ?></td>
                                <?php endif;
                                endforeach; 
                                ?>
                            </tr>
                            <?php endforeach; ?>
                        </tbody>
                    </table>
<?php
    }

}