<?php

class UserManager {
    
    private $userFile;
    private $adminList;
    private $allUserData;
    
    
    
    public function __construct() {
        $this->userFile = new CSVParser(CSVParser::USERLISTFILE);
        
        $this->parseUsers();
    }
    
    
    
    
    public function eraseUsers() {
        $this->adminList = array();
        $this->allUserData = array();
    }
    
    public function parseUsers() {
        $this->eraseUsers();
        
        foreach ($this->userFile->getCSVDataLines() as $user) {
            if (isset($user[2]) && $user[2]=="admin") {
                $this->adminList[] = $user[0];
            }
            $this->allUserData[$user[0]] = $user[1];
        }
    }
    
    public function persistNewUser($username, $password) {
        $this->allUserData[$username] = $password;
        $this->userFile->appendRecord(array($username, $password));
    }
    
    public function isLoggedIn() {
        if (isset($_SESSION["username"])) {
            return true;
        }
        return false;
    }
    
    public function isAdmin() {
        if ($this->isLoggedIn() && in_array($_SESSION["username"], $this->adminList)) {
            return true;
        }
        return false;
    }
    
    public function isAlreadyRegistered($username) {
        if (isset($this->allUserData[$username])) {
            return true;
        }
        return false;
    }
    
    public function isValidUser($username, $password) {
        if ($this->isAlreadyRegistered($username) && $this->allUserData[$username]==$password) {
            return true;
        }
        return false;
    }
    
    public function isValidEmail($email) {
        if (preg_match("/^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-z]{2,3})$/", $email)) {
            return true;
        }
        return false;
    }
    
    //36301234567
    public function isValidTel($tel) {
        if (preg_match("/^[0-9]{11}$/", $tel)) {
            return true;
        }
        return false;
    }
}