﻿<?php
    session_start();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

	<head>
		<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
		<title>Job-Offer Co.</title>
                <link rel="stylesheet" type="text/css" href="style.css" />
                <script type="text/javascript" src="jquery-1.7.2.js"></script>
	</head>
	<body>

<?php
    $PAGE = "fooldal";
     
    require_once 'CSVParser.php';
    require_once 'TableGenerator.php';
    require_once 'UserManager.php';
    require_once 'MenuManager.php';
    require_once 'FormGenerator.php';
    
    
    
    $USERS = new UserManager();
    $MENU = new MenuManager();
     
    if (isset($_GET["p"])) {
        $PAGE = $_GET["p"];
    }
    
    
    //////////////////////////////////////////////////////////////////////////////
    //////////////////////////// FŐOLDAL /////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////
    if ($PAGE == "fooldal") {
        $jobFile = new CSVParser(CSVParser::PROGRAMOFFERFILE);
        
        $jobListTable = new TableGenerator("programs");
        $jobListTable->setTableHead($jobFile->getCSVHeader());
        $chosenRows = $jobFile->getCSVDataLines();
        
        $applyFile = new CSVParser(CSVParser::APPLYLISTFILE);
        foreach ($chosenRows as &$rows) {
            foreach ($applyFile->getCSVDataLines() as $applies) {
                if ($applies[0] == $rows[0]) {
                    --$rows[5];
                }
            }
        }
        unset($rows);
        
        $chosen = "";
        if (isset($_POST["instituteform"]) && !empty($_POST["instituteform"]["chooser"])) {
            $chosen = $_POST["instituteform"]["chooser"];
            $rows = $chosenRows;
            $chosenRows = array();
            foreach ($rows as $row) {
                if ($row[1]==$chosen) {
                    $chosenRows[] = $row;
                }
            }
            $jobListTable->setTableBody($chosenRows);
        }
        else {
            $jobListTable->setTableBody($chosenRows);
        }
        $jobListTable->setTaskCol("Művelet", '<a href="?p=apply&id=%">Jelentkezés</a>');
        
        if (!$USERS->isLoggedIn()) {
            $jobListTable->setExcludeCols(array(6));
        }
        ?>
            
            <?php $MENU->render(); ?>
            <h3><?php echo $MENU->getTitleByPage($PAGE); ?></h3>
            <div class="content">
                <?php  $jobListTable->render(); ?>
            </div>
            <div>
                <?php 
                    $form = new FormGenerator("asd");
                    $url = $form->getCurrentURL();
                ?>
                <script type="text/javascript">
                    $(document).ready(function(){ 
                        $("#chooser").change(function(){
                            $("#instituteform").submit();
                        });
                    });
                </script>
                <form id="instituteform" action="<?php echo $url; ?>" method="POST">
                    <select id="chooser" name="instituteform[chooser]">
                        <option value="">Mind</option>
                        <?php
                            $rows = $jobFile->getCSVDataLines();
                            $institutes = array();
                            foreach ($rows as $row) {
                                if (!in_array($row[1], $institutes)) {
                                    $institutes[] = $row[1];
                                }
                            }

                            foreach ($institutes as $institute):
                        ?>
                        <option value="<?php echo $institute; ?>" <?php if($chosen==$institute) { echo 'selected="selected"'; } ?>><?php echo $institute; ?></option>
                        <?php
                            endforeach;

                        ?>
                    </select>
                </form>
            </div>
            
        <?php
    }
    //////////////////////////////////////////////////////////////////////////////
    //////////////////////////// BEJELENTKEZÉS ///////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////
    else if ($PAGE == "login") {
        $form = new FormGenerator("loginform");
        $form->addFormElement("text", "username", "Felhasználónév");
        $form->addFormElement("pass", "password", "Jelszó");
        $form->addSubmitButton("Bejelentkezés");
        
        if (isset($_POST["loginform"])) {
            $username = $_POST["loginform"]["username"];
            if ($USERS->isValidUser($username, $_POST["loginform"]["password"])) {
                $form->addFormSuccess("Sikeres bejelentkezés!");
                $_SESSION["username"] = $username;
            }
            else {
                $form->addFormError("Hibás felhasználónév vagy jelszó!");
            }
        }
        
        ?>
            
            <?php $MENU->render(); ?>
            <h3><?php echo $MENU->getTitleByPage($PAGE); ?></h3>
            <div class="content">
                <?php $form->render(); ?>
            </div>
           
        <?php
    }
    //////////////////////////////////////////////////////////////////////////////
    /////////////////////////// KIJELENTKEZÉS ////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////
    else if ($PAGE == "logout") {
        $_SESSION = array();
        session_destroy();
        session_regenerate_id(true);
        ?>
            
            <?php $MENU->render(); ?>
            <h3><?php echo $MENU->getTitleByPage($PAGE); ?></h3>
            <div class="content">
                <p class="success">A kijelentkezés sikeres!</p>
            </div>
           
        <?php
    }
    //////////////////////////////////////////////////////////////////////////////
    ////////////////////////// REGISZTRÁCIÓ //////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////
    else if ($PAGE == "reg") {
        $form = new FormGenerator("regform");
        $form->addFormElement("text", "username", "Felhasználónév");
        $form->addFormElement("pass", "password", "Jelszó");
        $form->addSubmitButton("Regisztráció");
        
        if (isset($_POST["regform"])) {
            $username = $_POST["regform"]["username"];
            $password = $_POST["regform"]["password"];
            if (empty($username) || empty($password)) {
                $form->addFormError("Minden mező kitöltése kötelező!");
            }
            else if ($USERS->isAlreadyRegistered($username)) {
                $form->addFormError("Foglalt felhasználónév!");
            }
            else {
                $form->addFormSuccess("Sikeres regisztráció!");
                $USERS->persistNewUser($username, $password);
                $_SESSION["username"] = $username;
            }
        }
        
        ?>
            
            <?php $MENU->render(); ?>
            <h3><?php echo $MENU->getTitleByPage($PAGE); ?></h3>
            <div class="content">
                <?php $form->render(); ?>
            </div>
           
        <?php
    }
    //////////////////////////////////////////////////////////////////////////////
    //////////////////////////// JELENTKEZÉS /////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////
    else if ($PAGE == "apply") {
        $pageTitle = "Jelentkezés";
        
        if (!$USERS->isLoggedIn()) {
        ?>
            
            <?php $MENU->render(); ?>
            <h3><?php echo $pageTitle; ?></h3>
            <div class="content">
                <p class="error">A funkció eléréséhez be kell jelentkezni!</p>
            </div>
           
        <?php
        }
        else if (!isset($_GET["id"]) || empty($_GET["id"])) {
        ?>
            
            <?php $MENU->render(); ?>
            <h3><?php echo $pageTitle; ?></h3>
            <div class="content">
                <p class="error">Nincs állás kiválasztva!</p>
            </div>
           
        <?php
        }
        else {
            $id = $_GET["id"];
        
            $form = new FormGenerator("applyform");
            $form->addFormElement("text", "name", "Név");
            $form->addFormElement("text", "email", "Email");
            $form->addFormElement("text", "tel", "Telefon");
            $form->addSubmitButton("Jelentkezem!");

            if (isset($_POST["applyform"])) {
                $name = $_POST["applyform"]["name"];
                $email = $_POST["applyform"]["email"];
                $tel = $_POST["applyform"]["tel"];
                if (empty($name) || empty($email) || empty($tel)) {
                    $form->addFormError("Minden mező kitöltése kötelező!");
                }
                else if (!$USERS->isValidEmail($email)) {
                    $form->addFormError("Hibás email cím!");
                }
                else if (!$USERS->isValidTel($tel)) {
                    $form->addFormError("Hibás telefonszám! Formátum: 36301234567");
                }
                else {
                    $form->addFormSuccess("Sikeres jelentkezés!");
                    $applies = new CSVParser(CSVParser::APPLYLISTFILE);
                    $applies->appendRecord(array($id,$name,$email,$tel));
                }
            }

            ?>

                <?php $MENU->render(); ?>
                <h3><?php echo $pageTitle; ?></h3>
                <div class="content">
                    <?php $form->render(); ?>
                </div>

            <?php
        }
    }
    //////////////////////////////////////////////////////////////////////////////
    /////////////////////////// ADMINISZTRÁCIÓ ///////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////
    else if ($PAGE == "admin") {
        
        if (!$USERS->isAdmin()) {
        ?>
            
            <?php $MENU->render(); ?>
            <h3><?php echo $MENU->getTitleByPage($PAGE); ?></h3>
            <div class="content">
                <p class="error">A funkciót csak adminisztrátorok használhatják!</p>
            </div>
           
        <?php
        }
        else {
            
            $applyFile = new CSVParser(CSVParser::APPLYLISTFILE);
            
            $data = $applyFile->getCSVDataLines();
            $name = array();
            foreach ($data as $key => $row) {
                $name[$key]  = $row[1];
            }
            array_multisort($name, SORT_ASC, $data);
            
            $applyListTable = new TableGenerator();
            $applyListTable->setTableHead($applyFile->getCSVHeader());
            $applyListTable->setTableBody($data);
            
            ?>

                <?php $MENU->render(); ?>
                <h3><?php echo $MENU->getTitleByPage($PAGE); ?></h3>
                <div class="content">
                    <?php $applyListTable->render(); ?>
                </div>
                <br>Összlétszám: <?php echo count($data); ?> fő
                
            <?php
        }
    }
    //////////////////////////////////////////////////////////////////////////////
    /////////////////////////// ERROR 404 ////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////
    else {
        ?>
            
            <h3 id="title">Hiba!</h3>
            <div class="content">
                <p class="error">A keresett oldal nem található!</p>
                <p><a href="/">Vissza a kezdőlapra</a></p>
            </div>
            
        <?php
    } //end if page
     
?>
	</body>
</html>
